/*
  deleting.h

  includes procedures for deleting FlowGraph's and ParseTree's 

*/

#ifndef _DELETING_H
#define _DELETING_H

#include <stdlib.h>
#include "framework.h"
#include "flownode.h"
#include "symboltable.h"
#include "labellist.h"


/*
  void deleteFlowNodeList(FlowNodeList l)
  deletes the given FlowNodeList l and frees the used memory
*/
void deleteFlowNodeList(FlowNodeList l);

/*
  void deleteFlowNode(FlowNode f, FrameWork fw)
  deletes the given FlowNode f (and the assigned
  (FrameWork-)Element of the Node (using fw->deleteElement)
*/
void deleteFlowNode(FlowNode f, FrameWork fw, int free_elems);


/*   void deleteFlowGraph(FlowGraph g) 
     deletes the given FlowGraph g and frees the used memory */
void deleteFlowGraph(FlowGraph g, FrameWork fw, int free_elems); 

/*
  void deleteFlowGraphElements(FlowGraph g)
  deletes the the FlowGraph (framework) elements
*/
void deleteFlowGraphElements(FlowGraph g, FrameWork fw); 

/*
  void deleteParseTree(ParseTree tree)
  frees the memory used by the given ParseTree
*/
void deleteParseTree(ParseTree tree);

/*
  void deleteSymbolTable(SymbolTable t)
  frees the symbol table
*/
void deleteSymbolTable(SymbolTable t);

/*
  void deleteLabelList(LabelList l)
  frees the LabelList l
*/
void deleteLabelList(LabelList l);


#endif

