/* flowrel_list.c
   11.6.2004
   
*/

#include "flowrel_list.h"


/*
  int FlowRelationListNull(FlowRelationList l)
  Returns:
  1: |l| = 0
  0: else
*/
int FlowRelationListNull(FlowRelationList l)
{
  return (l == NULL);
}


/*
  FlowRelationList FlowRelationListCreate(FlowGraph f, char direction)
  creates an FlowRelationList which includes all transisitions of the given
  FlowGraph f (which given direction: 1 bottom up, else top down)
*/
FlowRelationList FlowRelationListCreate(FlowGraph f, char direction)
{
  FlowRelationList result = NULL;
  FlowNodeList h1, h2;
  FlowRelationElement buffer;
  h1 = f->all;
  while (h1 != NULL)
    {
	/* add edges */
      if (direction == 1)
        h2 = h1->node->entry;
      else
        h2 = h1->node->exit;
      while (h2 != NULL)
        {
          buffer.from = h1->node;
          buffer.to = h2->node;
          result = FlowRelationListCons(buffer,result);
          h2 = h2->next;
       }
      h1 = h1->next;
    }
  return result;
}


/*
  FlowRelationElement FlowRelationListFirst(FlowRelationList l)
  First (CAR) operator for the FlowRelationList
*/
FlowRelationElement FlowRelationListFirst(FlowRelationList l)
{
  FlowRelationElement err;
  if (l != NULL)
    return l->value;
  else
    {
      err.from = NULL;
      err.to = NULL;
      return err;
    }
}


/*
  FlowRelationList FlowRelationListRest(FlowRelationList l)
  Rest (CDR) operator for the FlowRelationList
*/
FlowRelationList FlowRelationListRest(FlowRelationList l)
{
  if (l == NULL)
    return NULL;
  else
    return l->next;    
}


/*
  FlowRelationList FlowRelationListCons(FlowRelationElement el, FlowRelationList l)
  CONS operator for the FlowRelationList
*/
FlowRelationList FlowRelationListCons(FlowRelationElement el, FlowRelationList l)
{
  FlowRelationList h = l;
  
  while (h != NULL)
    {
      if ((h->value.from == el.from) && (h->value.to == el.to))
        return l;
      h = h->next;
    }

  FlowRelationList new_el;
  new_el = (FlowRelationList)malloc(sizeof(struct FlowRelationList_));
  new_el->value = el;
  new_el->next = l;
  return new_el;
}


