/* fw_init.h

Initialized Variables
*/

#include "fw_init.h"

/* constants */
extern SymbolTable vartable;

extern VarSet var_all;

char *fw_init_name = "Initialisierung von Variablen\0";

/* iota Element  */
Element init_iota()
{
    return VarSetMerge((Element)var_all, NULL);
}

Element init_supremum(Element a, Element b)
{
    return VarSetMerge((VarSet)a, (VarSet)b);
}

Element init_bottom()
{
    return NULL;
}

Element init_transfer(FlowNode g, Element a)
{
    VarSet result = VarSetMerge((VarSet)a, NULL) ;
    VarSet walker = (VarSet)a;
    int assigned = fwtools_assignedVariable(g->expr);
    if (assigned != -1)
    {
       	/* Assignment */
	while (walker != NULL)
	{
	    if ((fwtools_VariableinExpression(walker->val, getSubTree(g->expr, 1))))
	    {
		result = VarSetaddElement(result, assigned);
		return result;
	    }
	    else		
	    {
		walker = walker->next;
	    }
	}

       	result = VarSetremoveElement(result, assigned);
	return result;
    }
    else
	return result;
}

int init_eq(Element a, Element b)
{
    return VarSetEqual((VarSet)a, (VarSet)b);
}

void init_deref(Element a)
{
    VarSetDestroy((VarSet) a);
}

Element init_ref(Element a)
{
  return a;
}

char *init_print(Element a)
{
  return VarSetSPrint((VarSet) a);
}

int init_initfunc()
{
    return 1;
}

void init_finalizefunc()
{

}


FrameWork fw_init_createFrameWork(int direction)
{
  FrameWork result = (FrameWork)malloc(sizeof(struct FrameWork_));
  result->direction = direction;
  result->iota = (Iota)&init_iota;
  result->supremum = (Supremum)&init_supremum;
  result->bottom = (Bottom)&init_bottom;
  result->transfer = (Transfer)&init_transfer;
  result->eq = (Eq)&init_eq;
  result->deref = (DeRefElement)&init_deref;
  result->ref = (RefElement)&init_ref;
  result->printfunc = (PrintFunc)&init_print;
  result->initfunc = (InitFunc)&init_initfunc;
  result->finalizefunc = (FinalizeFunc)&init_finalizefunc;
  return result;
}
