/* fw_simple.c

  Simple Framework testing the abilities of framework.h
  
  Set: N| with inf (inf = -1)
  transfer-function: INC
  bottom = inf (= -1)

*/


#include <stdlib.h>
#include "fw_simple.h"


char *fw_simple_name = "Simple Analysis";
int fw_simple_null = 0;
int fw_simple_inf = -1;

Element simple_iota()
{
  int * element;
  element = (int *)malloc(sizeof(int));
  *element = 1;
  return element;
}

Element simple_supremum(Element a, Element b)
{
    int * result;
    result = (int *)malloc(sizeof(int));
    if (*((int *)a) == -1)
    {
	*result = *((int *)b);
	return result;
    }
    if (*((int *)b) == -1)
    {
	*result = *((int *)a);
	return result;
    }
	if (*((int *)a) <= *((int *)b)) 
	*result = *((int *)a);
	else *result = *((int *)b);
	return result;
}

Element simple_bottom()
{  
    return (void *)(&fw_simple_inf);
}

Element simple_transfer(FlowNode g, Element a)
{
    int *result = (int *) malloc(sizeof(int)); 
    if (*(int *)a != -1)
	*result = *((int *)a)+1;
    else
	*result = fw_simple_inf;
    return result;
}

int simple_eq(Element a, Element b)
{
  return (*((int *)a) == *((int *)b));
}

void simple_deref(Element a)
{
    free((int *)a);
}

Element simple_ref(Element a)
{
  return a;
}

char *simple_print(Element a)
{
  char *result;
  result = (char*)malloc(sizeof(char)*MAX_DIGITS_INT);
  sprintf(result, "%d", *((int*)a));
  return result;
}

int simple_initfunc()
{
    return 1;
}

void simple_finalizefunc()
{}

FrameWork fw_simple_createFrameWork(int direction)
{
    FrameWork result = (FrameWork)malloc(sizeof(struct FrameWork_));
    result->direction = direction;
    result->iota = (Iota)&simple_iota;
    result->supremum = (Supremum)&simple_supremum;
    result->bottom = (Bottom)&simple_bottom;
    result->transfer = (Transfer)&simple_transfer;
    result->eq = (Eq)&simple_eq;
    result->deref = (DeRefElement)&simple_deref;
    result->ref = (RefElement)&simple_ref;
    result->printfunc = (PrintFunc)&simple_print;
    result->initfunc = (InitFunc) &simple_initfunc;
    result->finalizefunc = (FinalizeFunc)&simple_finalizefunc;
    return result;
}
