/*
fwtools.h
12.06.2004

Provides functions for building frameworks

*/

#ifndef _FWTOOLS_H
#define _FWTOOLS_H

#include <stdlib.h>
#include "symboltable.h"
#include "parsetree.h"
#include "varset.h"

VarSet var_all;

/* important: this procedure has to be called AFTER building the 
FlowGraph
*/
/*
  void fwtools_init()
  initializes global variables etc.
  it is necessary to call this function BEFORE
  using the other functions of fwtools
*/
void fwtools_init();

/*
  int fwtools_assignedVariable(ParseTree t)
  if the given ParseTree t represents an assignment,
  the id of the assigned variable will be returned;
  else -1
*/
int fwtools_assignedVariable(ParseTree t);

/*
  int fwtools_VariableinExpression(int var, ParseTree t)
  returns:
  1 if the given variable var is part of the ParseTree t
  0 else
*/
int fwtools_VariableinExpression(int var, ParseTree t);


/*
  VarSet fwtools_allVariablesExpr(ParseTree t)
  Returns an VarSet which includes all variables of t
*/
VarSet fwtools_allVariablesExpr(ParseTree t);

/*
  VarSet fwtools_allVars()
  initializes the global variable var_all (list of all variables
  in the current program)
  is used in fwtools_init()
*/
VarSet fwtools_allVars();





#endif
