/*
  generic_list.c
  generic list structure
  19.5.2004
  
*/

#include "generic_list.h"

GenericList createGenericList(CompareFunc f)
{
  GenericList result;
  result = (GenericList)malloc(sizeof(struct GenericList_));
  if (result == NULL) return NULL;
  result->first = NULL;
  result->last = NULL;
  result->length = 0;
  return result;
}

GenericList GenericListAddElement(GenericList l, Element val, CompareFunc relation, int insertmode)
{
  GenericCell walker = l->first;
  GenericCell buffer;
  
  buffer = (GenericCell)malloc(sizeof(struct GenericCell_));
  if (buffer == NULL) return NULL;
  buffer->value = val;
  
  l->length++;
  
  if (l->first == NULL)
    {
      buffer->next = NULL;
      l->first = buffer;
      l->last = buffer;
      return l;
    }
  else
    {
      switch(insertmode)
        {
        case INSERT_LAST:
          buffer->next = NULL;
          l->last->next = buffer;
          l->last = buffer;
          return l;
        case INSERT_FIRST:
          buffer->next = l->first;
          l->first = buffer;
          return l;
        case INSERT_SORT:
          /* check if we need to insert at the very beginning */
          if ((int)((relation)(val,walker->value)))
            {
              buffer->next = l->first;
              l->first = buffer;
              return l;
            }
          while (walker->next != NULL)
            {
              if ((int)(relation)(val, walker->next->value))
                {
                  /* insertion */
                  buffer->next = walker->next;
                  walker->next = buffer;
                  return l;
                }
              else
                walker = walker->next;
            }
          /* else: insertion at the end */
          buffer->next = NULL;
          l->last->next = buffer;
          l->last = buffer;
          return l;
        default:
          /* default: insertion first */
          buffer->next = l->first;
          l->first = buffer;
          return l;
        }
    }
}

Element GenericListSearchElement(GenericList l, Element a, EqualFunc eq )
{
  GenericCell walker;
  walker = l->first;
  while (walker != NULL)
    {
	if ((int)(eq)(a, walker->value))
	    return walker->value;
	else
        walker = walker->next;
    }
  return NULL; /* nothing found */
}

Element GenericListFirst(GenericList l)
{
  return l->first;
}

Element GenericListlast(GenericList l)
{
  return l->last;
}


void GenericListApply(GenericList l,  ApplyFunc appfunc)
{
  int i = 0;
  GenericCell walker;
  getc(stdin);
  walker = l->first;
  getc(stdin);
  getc(stdin);
  
  while (walker != NULL)
  {
      (void)appfunc(walker->value);
      walker = walker->next;
      i++;
      printf("((%d, %d)) \n", i, walker == NULL);
  }
}
