/*
  generic_list.h
  generic list structure
  19.5.2004
  
*/

#ifndef _GENERIC_LIST_H
#define _GENERIC_LIST_H

#include <stdio.h>
#include <stdlib.h>


#define INSERT_LAST  1
#define INSERT_FIRST 2
#define INSERT_SORT 3 /* where to insert a new element */

typedef void *Element;
typedef int (*CompareFunc)(Element a, Element b);
typedef int (*EqualFunc)(Element a, Element b); 
typedef void (*ApplyFunc)(Element a);

typedef struct GenericCell_
{
  struct GenericCell_ *next;
  Element value;
} *GenericCell;


typedef struct GenericList_
{
  GenericCell first;
  GenericCell last;
  unsigned int length;
} *GenericList;


/* procedures & functions */

GenericList createGenericList();
GenericList GenericListAddElement(GenericList l, Element val, CompareFunc relation, int insertmode);
Element GenericListSearchElement(GenericList l, Element a, EqualFunc eq);
Element GenericListFirst(GenericList l);
Element GenericListLast(GenericList l);
void GenericListApply(GenericList l,  ApplyFunc appfunc);
/* GenericList findElement_Sorted(GenericList l, Element a, EqualFunc eq); */



#endif
