/* labellist.c

  28.04.2004

  Provides an ADT for storing
  the given label names

*/

#include "labellist.h"


/* LabelList createLabelList()
   Returns an empty LabelList
*/
LabelList createLabelList()
{
  return NULL;
}

LabelList addLabel(LabelList l, int id, char *name)
{
  LabelList newLabel, walker1, walker2;
  newLabel = malloc(sizeof(struct LabelList_));
  if (newLabel == NULL) return NULL;
  newLabel->id = id;
  newLabel->name = name;
  newLabel->next = NULL;
  
  if (l == NULL) return newLabel;

  /* special case: insertion at the beginning of the list */
  if (l->id > id)
    {
      newLabel->next = l;
      return newLabel;
    }

  walker1 = l;
  walker2 = l;
  
  /* the element has to be within the list or at the end of the list */
  while (walker1 != NULL)
    {
      if (walker1->id > id)
        {
          walker2->next = newLabel;
          newLabel->next = walker1;
          return l;
        }
      else
        {
          walker2 = walker1;
          walker1 = walker1->next;
        }
    }

  /* else, the label has to be inserted at the end of the list */
  walker2->next = newLabel;
  return l;
  
}


int existsLabel(LabelList l, int id)
{
  LabelList walker = l;

  while (walker != NULL)
    {
      if (walker->id == id)
        return 1;
      if (walker->id > id)
        return 0;
      walker = walker->next;
    }
  return 0;
}


char *findLabelbyID(LabelList l, int id)
{
  LabelList walker = l;
  
  while (walker != NULL)
    {
      if (walker->id == id)
        return walker->name;
      walker = walker->next;
    }
  return NULL;
}


int findLabelbyName(LabelList l, char * s)
{
  LabelList walker = l;

  while (walker != NULL)
    {
      if (strcmp(walker->name, s) == 0)
        return walker->id;
      walker = walker->next;
    }
  return -1;  
}

