/* main_prog.c

  Includes basic procedures and the 
  main procedure of wanalyzer   

   2.08.2004

wAnalyzer, written by Andreas Gaiser & Frederik Stahr
(C) 2004

This program is free software; you can redistribute 
it and/or modify it under the terms of the GNU 
General Public License as published by the Free
Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it
will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU 
General Public License along with
this program; if not, write to the
Free Software Foundation, Inc., 675 Mass
Ave, Cambridge, MA 02139, USA. 
 
*/ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "textctrl.h"
#include "guictrl.h"



int stepmode;
int guimode = 0;

/*
  void prompt(char *msg, char *end)
  if wanalyzer is in gui-mode,
    prompt will send a message with
    the given Message / End-indicating string
    to the gui script; else, it will
    print the message msg to stdout
*/

void prompt(char *msg, char *end)
{
  if (guimode) /*graphical mode */
    {
      printf("PROMPT\n%s\n%s\n", msg, end);
    }
  else /*text mode*/
    {
      printf("%s \n(%s zum Beenden)\n", msg, end);
    }
}


/* 
  Command line arguments of wanalyzer:
  
  wanalyzer [-gui | -step] <FILENAME>
   
   -gui   Use the graphical interface 
          else, the textbased interface is used
   -step  The Program Analysis will be step by step
   
   <FILENAME> code file
*/


int main(int argc, char** argv)
{
  int i;
  
  /* initializing global variables */
  stepmode = 0;
  
  if ((argc == 1) || (argc > 3))
    {
      printf("Gebrauch: wanalyzer [-gui | -step] <FILENAME>\n");
      return;
    }
  
  
  if (strcmp(argv[1], "-gui") == 0)
    {
      /* start the graphical interface */
      guimode = 1;
      guicontrol();
      return 1;
    }
  else if (strcmp(argv[1], "-step") == 0)
    {
      if ((argc == 2) || (argc != 3)) 
	{
	  printf("Gebrauch: wanalyzer [-gui | -step] <FILENAME>\n");
	  return 1;
	}
      /* setting stepmode to true */
      printf("Step mode\n");
      stepmode = 1;
      /* file open */
        textcontrol(argv[2]);
        return 1;
   }
  
  if (argc == 2)
    {
      printf("Datei wird geoeffnet\n");
      textcontrol(argv[1]);
    }
    
  return 1;

}

