/* worklist.h 
   08.06.2004
   Provides the worklist algorithm
   for the data flow analysis
*/

#ifndef _WORKLIST_H
#define _WORKLIST_H

#include <stdlib.h>
#include "flownode.h"
#include "flowrel_list.h"
#include "frame_managing.h"

/*
  int ProgramAnalysis(FlowNode f, FrameWork fw)
  Makes an Flow analysis with the given FlowGraph
  and FrameWork using the Worklist algorithm for 
  calculating the least (maximal) fixed points of
  the FlowNode equations
*/
int ProgramAnalysis(FlowGraph f, FrameWork fw);

/*
  void initWorkList(FlowGraph f, FrameWork fw)
  initalizes the WorkList
*/
int initWorkList(FlowGraph f, FrameWork fw);

/*
  int stepWorkList(FlowGraph f, FrameWork fw)
  makes one step of the worklist algorithm:
  returns 1: if the algorithm has finished
          0: else
*/
int stepWorkList(FlowGraph f, FrameWork fw);
#endif
